#define RNV_SUM 0
#define RNV_PRODUCT 1
#define RNV_MAX 0
#define RNV_MIN 0x7fffffff
#define RNV_INDEX_MAX 0

void for_loop(int i, int n, void (*body)(int, void *), void *arg_body);
int for_ex_cond(int i, int n, int (*cond)(int, void *), void *arg_cond, void (*body)(int, void *), void *arg_body);
int for_in_cond(int i, int n, int (*cond)(int, void *), void *arg_cond, void (*body)(int, void *), void *arg_body);
int for_reduce(int i, int n, int rnv, int (*get)(int, void *), void *arg_get, int (*reduce)(int, int, int, int, void *), void *arg_reduce);
int for_ex_cond_reduce(int i, int n, int rnv, int (*cond)(int, void *), void *arg_cond, int (*get)(int, void *), void *arg_get, int (*reduce)(int, int, int, int, void *), void *arg_reduce);
int for_in_cond_reduce(int i, int n, int rnv, int (*cond)(int, void *), void *arg_cond, int (*get)(int, void *), void *arg_get, int (*reduce)(int, int, int, int, void *), void *arg_reduce);
int reduce_sum(int i, int n, int a, int b, void *arg);
int reduce_product(int i, int n, int a, int b, void *arg);
int reduce_max(int i, int n, int a, int b, void *arg);
int reduce_min(int i, int n, int a, int b, void *arg);
int reduce_index_of_max(int i, int n, int a, int b, void *arg);
int reduce_index_of_min(int i, int n, int a, int b, void *arg);
int reduce_gt_index(int i, int n, int a, int b, void *arg);
int reduce_lt_index(int i, int n, int a, int b, void *arg);
void produce_int(int k, int i);
void consume_int(int k, int i, int n);
void update_int(int k, int n);
void for_loop_produce_int(int k, int i, int n, void (*body)(int, int, void *), void *arg_body, void (*produce_int)(int, int));
void for_loop_consume_int(int k, int i, int n, int size, void (*body)(int, int, int, void *), void *arg_body, void (*consume_int)(int, int, int));
void for_loop_update_int(int k, int i, int n, int size, void (*body)(int, int, int, void *), void *arg_body, void (*update_int)(int, int));
void send_int(int k, int v);
int receive_int(int k);
void init_canal();
void dump_canal(int k);
